import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React, { useState, useEffect, useRef } from 'react';
import PropTypes from 'prop-types';
import Input from '../Input';

var MaskInput = function MaskInput(_ref) {
  var name = _ref.name,
      onChange = _ref.onChange,
      maskOptions = _ref.mask,
      props = _objectWithoutPropertiesLoose(_ref, ["name", "onChange", "mask"]);

  var _useState = useState(null),
      mask = _useState[0],
      setMask = _useState[1];

  var refInput = useRef(null);
  useEffect(function () {
    return function () {
      return mask && mask.destroy();
    };
  }, [mask]);

  var handleChange = function handleChange(ev, _ref2) {
    var value = _ref2.value;
    onChange(ev, {
      value: value
    });
  };

  var handleFocus = function handleFocus() {
    if (!mask) {
      import('imask').then(function (_ref3) {
        var IMask = _ref3["default"];
        setMask(new IMask(refInput.current, maskOptions));
      });
    }
  };

  return React.createElement(Input, Object.assign({
    id: name,
    reference: refInput,
    onChange: handleChange,
    onFocus: handleFocus
  }, props));
};

MaskInput.displayName = 'MaskInput';
MaskInput.defaultProps = {
  onChange: function onChange() {}
};
export default MaskInput;